/*
 * Secure X Message Passing Library v2 implementation.
 * (sxmplv2) it superseed all versions before due to the:
 * - memory consumption
 * - new features such as pulse emitting
 * - performance optimization
 *
 * (c) Askele Group 2013-2015 <http://askele.com>
 * (c) Alexander Vdolainen 2013-2015 <avdolainen@gmail.com>
 *
 * libsxmp is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libsxmp is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.";
 *
 */

#ifndef __SXMP_LIMITS_H__
#define	__SXMP_LIMITS_H__

#define MAX_RPC_LIST  512

#define MAX_SXMPLBUFSIZE  65536
#define MAX_RBBUF_LEN  (MAX_SXMPLBUFSIZE - sizeof(sxmplv2_head_t))

#define MAX_SXMPLTHREADS  8

#define MAX_MSGINPROCESS     1024
#define MAX_CHANNELSOPENED   512
#define MAX_STREAMSOPENED    256

#define MAX_STREAMS_TYPES    32767

#define MAX_LINKS  32768

#define MAX_SXMP_SYNC_ITERATIONS  6

#endif /* __SXMP_LIMITS_H__ */
